(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('create-subscription'), require('react')) :
    typeof define === 'function' && define.amd ? define(['exports', 'create-subscription', 'react'], factory) :
    (factory((global['react-with-observable'] = {}),global.createSubscription,global.React));
}(this, (function (exports,createSubscription,React) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function symbolObservablePonyfill(root) {
    	var result;
    	var Symbol = root.Symbol;

    	if (typeof Symbol === 'function') {
    		if (Symbol.observable) {
    			result = Symbol.observable;
    		} else {
    			result = Symbol('observable');
    			Symbol.observable = result;
    		}
    	} else {
    		result = '@@observable';
    	}

    	return result;
    }

    /* global window */

    var root;

    if (typeof self !== 'undefined') {
      root = self;
    } else if (typeof window !== 'undefined') {
      root = window;
    } else if (typeof global !== 'undefined') {
      root = global;
    } else if (typeof module !== 'undefined') {
      root = module;
    } else {
      root = Function('return this')();
    }

    var result = symbolObservablePonyfill(root);

    var Subscribe = /** @class */ (function (_super) {
        __extends(Subscribe, _super);
        function Subscribe() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.SubscriptionComponent = _this.getSubscriptionComponent();
            return _this;
        }
        Subscribe.prototype.render = function () {
            var observable = this.getObservableFromChildren();
            return (React.createElement(this.SubscriptionComponent, { source: observable }, function (val) {
                if (typeof val === 'undefined') {
                    return '';
                }
                return val;
            }));
        };
        Subscribe.prototype.getObservableFromChildren = function () {
            var child = this.props.children;
            var observable = typeof child[Symbol.observable] === 'function' ? child[Symbol.observable]() : undefined;
            if (!observable) {
                throw new Error("<Subscribe>: Expected children to be a single Observable instance with a [Symbol.observable] method. See more: https://github.com/tc39/proposal-observable");
            }
            return observable;
        };
        Subscribe.prototype.getSubscriptionComponent = function () {
            var SubscriptionComponent = createSubscription.createSubscription({
                getCurrentValue: function (_observable) {
                    return undefined;
                },
                subscribe: function (observable, callback) {
                    var subscription = observable.subscribe(callback);
                    return function () { return subscription.unsubscribe(); };
                },
            });
            return SubscriptionComponent;
        };
        return Subscribe;
    }(React.Component));

    exports.Subscribe = Subscribe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
